/*
 * The contents of this file are subject to the Mozilla Public
 * License Version 1.1 (the "License") you may not use this file
 * except in compliance with the License. You may obtain a copy of
 * the License at http://www.mozilla.org/MPL/
 * 
 * Software distributed under the License is distributed on an "AS
 * IS" basis, WITHOUT WARRANTY OF ANY KIND, either express or
 * implied. See the License for the specific language governing
 * rights and limitations under the License.
 * 
 * The Original Code in this file was released April 1, 2001
 * 
 * The Initial Developer of the Original Code is Henk-Johan van Rantwijk.
 * all Portions created by Henk-Johan van Rantwijk are Copyright (C) 2001
 * by Henk-Johan van Rantwijk. All Rights Reserved.
 * 
 * Contributor(s):
 *   Henk-Johan van Rantwijk <bugs4hj@netscape.net> (Original Author)
 *   David Perry <d.perry@utoronto.ca>
 *   Neil Pryde <NeilPryde92651@netscape.net> (well I'm just HJ's typewriter)
 * 
 */

////////////////////////////////////////////////////////////////////////////////
// this function opens the TabList Dialog where you can activate a selected tab
////////////////////////////////////////////////////////////////////////////////
function openTabListDialog()
{
  var tabId   = null;
  var uriList = new Array();
  gBrowser    = getBrowser();
  var l       = gBrowser.mTabContainer.childNodes.length;

  for ( var i = 0; i < l; i++ )
    uriList[ i ] = gBrowser.mPanelContainer.childNodes[i].webNavigation.currentURI.spec;

  window.openDialog( "chrome://multiviews/content/multiviewsTabList.xul",
                     "multiviewsTabList",
                     "chrome, dependent, modal, dialog, resizable",
                     gBrowser.mTabContainer,
                     uriList );

  if ( uriList[ 0 ] >= 0 )
   gBrowser.selectedTab = gBrowser.mTabContainer.childNodes[uriList[0]];
}
////////////////////////////////////////////////////////////////////////////////
// this function hides the first two menuitems, and removes all bookmark items
////////////////////////////////////////////////////////////////////////////////
function cleanupForTabGroups( aFolder )
{
  var children = aFolder.childNodes;
  var type;
  // itterate over all menu items
  for ( var i = 0; i < children.length; i++ ) {
    if ( children[ i ].getAttribute( "folder" ) ) {
      // we found a bookmark folder so get rid of the bookmark items
      for ( i = 0; i < children.length; i++ ) {
        if ( children[ i ].getAttribute( "item" ) )
          aFolder.removeChild( children[ i ] );
      }
      // hide 'Open This Folder As Group' and the corresponding separator
      if ( !children[ 0 ].getAttribute( "hidden" ) ) {
        children[ 0 ].setAttribute( "hidden", "true" );
        children[ 1 ].setAttribute( "hidden", "true" );
      }
      break;
    }
  }
}
////////////////////////////////////////////////////////////////////////////////
// this function loads the selected Bookmark Folder as group
////////////////////////////////////////////////////////////////////////////////
function loadFolderAsGroup( aFolder )
{
  var children = aFolder.childNodes;
  var tabOpen = readMyPref( "multizilla.newtabfor.groupfolders", "bool", false );
  var tabPanels = getBrowser().mPanelContainer.childNodes;
  var tabCount = tabPanels.length;
  var uri;
  // itterate over all menu items but skip the first two
  for ( var i = 2; i < children.length; i++ ) {
    uri = children[ i ].getAttribute( "url" );
    if ( !tabOpen && ( i - 2 ) < tabCount )
      tabPanels[ i - 2 ].loadURI( uri, null, nsIWebNavigation.LOAD_FLAGS_NONE );
    else
      getBrowser().addTab( uri );
  }
}
////////////////////////////////////////////////////////////////////////////////
// this function 'hides' the selected tab for Close All
////////////////////////////////////////////////////////////////////////////////
function hideTab( aTab )
{
  var clsTab =  "close";

  if ( aTab.hasAttribute( clsTab ) )
    aTab.removeAttribute( clsTab );
  else aTab.setAttribute( clsTab, "true" );
}
////////////////////////////////////////////////////////////////////////////////
// this function re-loads 'firstPage' (if it isn't the same as the current URI)
////////////////////////////////////////////////////////////////////////////////
function loadFirstTabPage()
{
  var mTab = gBrowser.selectedTab;
  var mURI =  mTab.getAttribute( "firstPage" );

  if ( mURI != gBrowser.currentURI.spec )
    loadURI( mURI );
}
////////////////////////////////////////////////////////////////////////////////
// this function opens the "Close All - Keep List" dialog
////////////////////////////////////////////////////////////////////////////////
function closeAllTabsDialog()
{
    var tabList = new Array(); // list of tabs to pass to dialog
    gBrowser    = getBrowser();
    var l       = gBrowser.mTabContainer.childNodes.length;

    for ( var i = 0; i < l; i++ ) {
      var tabTab      = new Object();
      tabTab.name     = gBrowser.mTabContainer.childNodes[ i ].getAttribute( "label" );
      tabTab.URI      = gBrowser.mPanelContainer.childNodes[ i ].webNavigation.currentURI.spec;
      tabTab.closable = gBrowser.mTabContainer.childNodes[ i ].getAttribute( "close" ) ? false : true;
      tabTab.closeMe  = "false";
      tabList[ i ]    = tabTab;
    }
    window.openDialog( "chrome://multiviews/content/multiviewsClose.xul",
                       "multiviewsClose", "chrome,dependent,modal,dialog,resizable", tabList );

    try {
      var mvTabArray = new Array();
      var noCurr = false; // set to true if we remove current tab
      for ( var v = 0; v < l; v++ ) {
        mvTabArray[ v ] = gBrowser.mTabContainer.childNodes[ v ];
      }
      v--;
      while ( v >= 0 ) {
        if ( tabList[ v ].closeMe == "true" ) {
          if ( gBrowser.mTabContainer.childNodes.length > 0 ) {
            if ( !noCurr && mvTabArray[ v ] == gBrowser.mTabContainer.selectedItem )
              noCurr = true;
            gBrowser.removeTab( gBrowser.mTabContainer.childNodes[v] );
          }
          else {
            loadFirstBlank();
            break;
          }
        }
        v--;
      }
    } catch( ex ) { dump( ex+"\n" ); }
}
////////////////////////////////////////////////////////////////////////////////
// this function adds a new Preferred Tab
////////////////////////////////////////////////////////////////////////////////
function addNewPreferredTab()
{
  var aPreferredURI = readMyPref( "multizilla.preferred.location", "string", 
                                  "http://multizilla.mozdev.org/index.html" );
  gBrowser.selectedTab = gBrowser.addTab( aPreferredURI );
  return;
}
////////////////////////////////////////////////////////////////////////////////
// this function adds session history to the selected menu
////////////////////////////////////////////////////////////////////////////////
function FillSelectedHistoryMenu(aParent, aMenu)
{
  deleteHistoryItems(aParent);
  var sessionHistory = getWebNavigation().sessionHistory;
  var count = sessionHistory.count;
  var index = sessionHistory.index;
  var end;
  var j;
  var entry;

  switch (aMenu)
    {
      case "go":
        aParent.lastChild.hidden = (count == 0);	
        end = count > MAX_HISTORY_MENU_ITEMS ? count - MAX_HISTORY_MENU_ITEMS : 0;
        for (j = count - 1; j >= end; j--) {
          entry = sessionHistory.getEntryAtIndex(j, false);
          if (entry)
            createRadioMenuItem(aParent, j, entry.title, j==index);
        }
      break;
      case "tab":
        aParent.lastChild.hidden = (count > 0);	
        end = count > MAX_HISTORY_MENU_ITEMS ? count - MAX_HISTORY_MENU_ITEMS : 0;
        for (j = count - 1; j >= end; j--) {
          entry = sessionHistory.getEntryAtIndex(j, false);
          if (entry)
            createRadioMenuItem(aParent, j, entry.title, j==index);
        }
      break;
    }
}